#ifndef FIGURE_H
#define FIGURE_H

namespace nqueens
{
   class Figure
   {
    public:
      Figure(int in_ID): ID{in_ID} {}
      Figure(int in_ID, int in_x, int in_y): ID{in_ID}, x{in_x}, y{in_y} {}

      int getID() const { return this->ID; }
      int getx() const { return this->x; }
      int gety() const { return this->y; }

      void setx(int in_x) { this->x = in_x; }
      void sety(int in_y) { this->y = in_y; }

    private:
      int ID = 0;
      int x = 0;
      int y = 0;
   };
   
   inline bool operator==(const Figure& a, const Figure& b) { return a.getID() == b.getID(); }
   inline bool operator<(const Figure& a, const Figure& b) { return a.getID() < b.getID(); }

   class Queen: public Figure
   {
    public:
      Queen(int in_ID): Figure(in_ID) {}
      Queen(int in_ID, int in_x, int in_y): Figure(in_ID, in_x, in_y) {}
   };
}

#endif
