#include <cassert>  // assert
#include <cstdlib>  // std::atoi
#include <iostream>  // std::cout

#include "configuration.h"
#include "figure.h"
#include "random-config.h"

int main(int argc, char** argv)
{
   int N_queens = 8;  // number of queens
   if(argc > 1) N_queens = std::atoi(argv[1]);
   assert(N_queens >= 0);
   
   nqueens::Board b;
   b.lx = 8;  // size in x direction
   if(argc > 2) b.lx = std::atoi(argv[2]);
   assert(b.lx >= 1);
   
   b.ly = 8;  // size in y direction
   if(argc > 3) b.ly = std::atoi(argv[3]);
   assert(b.ly >= 1);
   
   nqueens::Configuration c(b);
   nqueens::add_random_queens(&c, N_queens);
   
   long num_threats = c.count_threats();
   std::cout << "==\nThreats counted: " << num_threats << ".\n";
}
